#ifndef __HASH__H
#define __HASH__H

// Hash function based on djb2 from Dan Bernstein
// http://www.cse.yorku.ca/~oz/hash.html
//
// @return computed hash value

unsigned int hash_fct(char *str)
{
	unsigned int hash = 5381;
	int c;

	while ( (c = *str ++) != 0 ) {
		hash = ((hash << 5) + hash) + c;
	}

	return hash;
}

#endif // __HASH__H
