#ifndef __HASHTABLE__H
#define __HASHTABLE__H

#include <list>

template<typename Tkey, typename Tvalue>
struct elem_info {
	Tkey key;
	Tvalue value;
};


template<typename Tkey, typename Tvalue>
class Hashtable {
	private:
		std::list<struct elem_info<Tkey, Tvalue> > *H;
		int HMAX;
		unsigned int (*hash) (Tkey);
	public:
		Hashtable(int hmax, unsigned int (*h)(Tkey)) : HMAX(hmax), hash(h)
		{
			H = new std::list<struct elem_info<Tkey, Tvalue> >[hmax];
		}

		~Hashtable()
		{
			delete H;
		}

		void put(Tkey key, Tvalue value)
		{
			struct elem_info<Tkey, Tvalue> e;

			e.key = key;
			e.value = value;

			std::cout << "Size " << H[getKey(key)].size() << "\n";
			H[getKey(key)].push_back(e);
		}

		unsigned int getKey(Tkey key)
		{
			return hash(key) % HMAX;
		}

		void remove(Tkey key)
		{
			unsigned int index = hash(key);
			typename std::list<
				struct elem_info<Tkey, Tvalue> >::iterator it;
			for (it = H[index].begin(); it != H[index].end(); it++) {
				std::cout << "ky " << it->key << "\n";
			}
		}

		Tvalue get(Tkey key) { Tvalue v; return v; }
		bool has_key(Tkey key) { return true; }
};

#endif // __HASHTABLE__H
